package cnu.app;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Toast;

public class Goal_Time extends Activity {

	private Button BT_save;
	private Button BT_exit;
	private EditText ET_auto;
	private EditText ET_year;
	private EditText ET_month;
	private EditText ET_day;
	private EditText ET_hour;
	private EditText ET_min;
	private int nDaysList[] = {31 , 28 , 31 , 30 ,31 ,30, 31, 31 , 30 ,31 ,30 ,31};
	
	Date Time;
	public RadioGroup RG_time_group;
	Handler mHandler;
	MediaPlayer mp;

	byte[] setting = new byte[10];// [0]RadioGroup,[1]nð,[2],[3],[4],[5],[6~9]

	/** Called when the activity is first created. */
	@Override
	/**
	 * ð 
	 */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.goal_time);

		RG_time_group = (RadioGroup)findViewById(R.RadioGroup.Time_group);
		BT_save = (Button)findViewById(R.Button.time_save);	
		BT_exit = (Button)findViewById(R.Button.time_cancel);

		ET_auto = (EditText)findViewById(R.EditText.ET_Auto);		
		ET_year = (EditText)findViewById(R.EditText.ET_year);	// Է° 
		ET_month = (EditText)findViewById(R.EditText.ET_month);
		ET_day = (EditText)findViewById(R.EditText.ET_day);
		ET_hour = (EditText)findViewById(R.EditText.ET_hour);
		ET_min = (EditText)findViewById(R.EditText.ET_min);

		load_file();

		switch(RG_time_group.getCheckedRadioButtonId()){
		case R.RadioButton.RB_Auto:
			ET_auto.setEnabled(true);
			ET_year.setEnabled(false);
			ET_month.setEnabled(false);
			ET_day.setEnabled(false);
			ET_hour.setEnabled(false);
			ET_min.setEnabled(false);
			break;
		case R.RadioButton.RB_Manual:
			ET_auto.setEnabled(false);
			ET_year.setEnabled(true);
			ET_month.setEnabled(true);
			ET_day.setEnabled(true);
			ET_hour.setEnabled(true);
			ET_min.setEnabled(true);
			break;
		}
		
		RG_time_group.setOnCheckedChangeListener(
				new RadioGroup.OnCheckedChangeListener(){

					public void onCheckedChanged(RadioGroup group, int checkedId) {
						switch(checkedId){
						case R.RadioButton.RB_Auto:
							ET_auto.setEnabled(true);
							ET_year.setEnabled(false);
							ET_month.setEnabled(false);
							ET_day.setEnabled(false);
							ET_hour.setEnabled(false);
							ET_min.setEnabled(false);
							break;
						case R.RadioButton.RB_Manual:
							ET_auto.setEnabled(false);
							ET_year.setEnabled(true);
							ET_month.setEnabled(true);
							ET_day.setEnabled(true);
							ET_hour.setEnabled(true);
							ET_min.setEnabled(true);
							break;
						}
					}
				}
		);	
		
		BT_save.setOnClickListener(				//  ư 
				new View.OnClickListener(){   
					public void onClick(View v) {
						if (Save_Time()){
							save_file();
							Goal_Main.print_time(Goal_Main.set_time);
							finish();
						}
					}
				}
		);

		BT_exit.setOnClickListener(				//  ư
				new View.OnClickListener(){   
					public void onClick(View v) {
						finish();
					}
				}
		);
	}
	/**
	 *  ð 
	 * @return true=, false=
	 */
	boolean Save_Time(){ 		
		boolean flag=true;
		switch(RG_time_group.getCheckedRadioButtonId()){ 
		case R.RadioButton.RB_Auto:		// nð  
			if (ET_auto.getText().toString().equals("")){
				flag = false;
				Toast.makeText(Goal_Time.this, " Էּ", Toast.LENGTH_LONG).show();
			}
			else  flag = Auto_Time();
			break;
		case R.RadioButton.RB_Manual:	//  Է
			if (ET_year.getText().toString().equals("") ||
					ET_month.getText().toString().equals("")||
					ET_day.getText().toString().equals("")||
					ET_hour.getText().toString().equals("")||
					ET_min.getText().toString().equals("")){
				flag = false;
				Toast.makeText(this, " Է ּ", Toast.LENGTH_SHORT).show();
			}
			else{
				flag = Manual_Time();
			}
			break;
		}	
		if(flag){
			if(Goal_Alarm.alarm_time)	// ˶ üũ ȮϿ 
				Goal_Alarm.Alarm_Time(Goal_Main.set_time, getBaseContext());		
			if(Goal_Alarm.alarm_hour_time)
				Goal_Alarm.Alarm_Hour_Time(Goal_Main.set_time, getBaseContext());
		}
		return flag; 
	}
	/**
	 * n ð ð ϱ
	 * @return true=, false=
	 */
	boolean Auto_Time(){	
		// Է° 
		try{
			int get_time = Integer.parseInt(ET_auto.getText().toString());	

			if(get_time > 0){
				get_time = get_time*1000*60*60; // иʷ ٲ

				Time = new Date(); // ð 
				long time = Time.getTime();
				time += get_time;		// ð + nð

				Goal_Main.set_time = time;

				return true;
			}
			else{
				Toast.makeText(Goal_Time.this, "  Ȯּ", Toast.LENGTH_SHORT).show();
				return false;
			}
		}
		catch (Exception e) {
			Toast.makeText(Goal_Time.this, "ڸ Էּ", Toast.LENGTH_SHORT).show();
			return false;
		}

	}
	/**
	 *   ð Է½ 
	 * @return true=, false=
	 */
	boolean Manual_Time(){	

		try{
			int year = Integer.parseInt(ET_year.getText().toString());
			int month = Integer.parseInt(ET_month.getText().toString());
			int day = Integer.parseInt(ET_day.getText().toString());
			int hour = Integer.parseInt(ET_hour.getText().toString());
			int min = Integer.parseInt(ET_min.getText().toString());

			if(year < 1){
				Toast.makeText(Goal_Time.this, year+" ٽ Ȯֽʽÿ", Toast.LENGTH_SHORT).show();
				return false;
			}
			if(month < 1 || month > 12){
				Toast.makeText(Goal_Time.this, month+" ٽ Ȯֽʽÿ", Toast.LENGTH_SHORT).show();
				return false;
			}
			if(day < 1 || day > getDays(year,month) ){
				Toast.makeText(Goal_Time.this, day+" ٽ Ȯֽʽÿ", Toast.LENGTH_SHORT).show();
				return false;
			}
			if(hour < 0 || hour >24){
				Toast.makeText(Goal_Time.this, hour+"ð ٽ Ȯֽʽÿ", Toast.LENGTH_SHORT).show();
				return false;
			}
			if(min < 0 || min > 60){
				Toast.makeText(Goal_Time.this, min+" ٽ Ȯֽʽÿ", Toast.LENGTH_SHORT).show();
				return false;
			}

			Date dt = new Date(Integer.toString(year)+"/"+Integer.toString(month)+"/"+Integer.toString(day));	// ش ¥ ͸

			long time = dt.getTime();		// и ʷ ٲ
			time += hour*3600000 + min*60000;	// ð  

			Goal_Main.set_time = time;	// 

			return true;
		}
		catch (Exception e) {
			Toast.makeText(Goal_Time.this, "ڸ Էּ", Toast.LENGTH_SHORT).show();
			return false;
		}
	}
	/**
	 * Ͽ   ҷ
	 */
	private void load_file(){
		FileInputStream mFileInputStream;
		FileOutputStream mFileOutputStream;

		//Ͽ ɼ  б
		try {
			mFileInputStream = openFileInput("save_time");
			mFileInputStream.read(setting);
		} catch (IOException e){
			for ( int i=0 ; i < 10; i ++) setting[i]=0;
			try {
				mFileOutputStream = openFileOutput("save_time", MODE_WORLD_WRITEABLE);
				mFileOutputStream.write(setting);
			} catch (IOException e1) {
				Log.d("mylog","can't write");
			}
			Log.d("mylog","can't read");
		}
		if(setting[0]==1)
			RG_time_group.check(R.RadioButton.RB_Auto);
		else if(setting[0]==2)
			RG_time_group.check(R.RadioButton.RB_Manual);

		ET_auto.setText(Byte.toString(setting[1]));
		ET_month.setText(Byte.toString(setting[2]));
		ET_day.setText(Byte.toString(setting[3]));
		ET_hour.setText(Byte.toString(setting[4]));
		ET_min.setText(Byte.toString(setting[5]));

		int count=0;
		for(int i=0;i<4;i++){
			if(setting[6+i]==0) break;
			count++;
		}
		String syear = new String(setting,6,count);
		ET_year.setText(syear);
	}
	/**
	 * Ͽ   ϱ
	 */
	void save_file(){

		int i;
		FileOutputStream mFileOutputStream;

		switch(RG_time_group.getCheckedRadioButtonId()){ 
		case R.RadioButton.RB_Auto:		// nð  
			setting[0]=1;
			break;
		case R.RadioButton.RB_Manual:	//  Է
			setting[0]=2;

			break;
		}	
		String strNum = ET_auto.getText().toString(); //  
		String syear = ET_year.getText().toString();	
		String smonth = ET_month.getText().toString();
		String sday = ET_day.getText().toString();
		String shour = ET_hour.getText().toString();
		String smin = ET_min.getText().toString();

		setting[1] = Byte.parseByte(strNum);
		setting[2] = Byte.parseByte(smonth);
		setting[3] = Byte.parseByte(sday);
		setting[4] = Byte.parseByte(shour);
		setting[5] = Byte.parseByte(smin);	

		for (  i =0 ; i < syear.length(); i ++)
			setting[i+6] = syear.getBytes()[i]; 
		for (i = i+6; i < 10; i ++)	setting[i] = 0;
		//Ͽ ɼ  
		try {
			mFileOutputStream = openFileOutput("save_time", MODE_WORLD_WRITEABLE);
			mFileOutputStream.write(setting);
		} catch (IOException e) {
			Log.d("mylog","can't write");
		}		
	}
	
	/**
	 * ش / ϼ ´..
	 * @param year ⵵
	 * @param month 
	 * @return ش / ϼ
	 */
	private int  getDays(int year, int month ) {
		if (month  == 2){
			if(((year%4 == 0)&&(year%100 != 0)) ||(year%400 == 0)){
				return(29);
			}
		}
		return(nDaysList[month-1]);
	}
}
