package cnu.app;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioGroup;
import android.widget.Toast;

public class Goal_Type extends Activity {

	private Button BT_save;
	private Button BT_exit;
	private EditText ET_Step;
	static EditText ET_Km;
	static EditText ET_Kcal;

	static int goal_type;	// 1=step, 2=km, 3=kcal
	static int goal_count;
	static int goal_percent;

	Date Time;
	public RadioGroup RG_goal_group;
	Handler mHandler;
	MediaPlayer mp;

	byte setting[] = new byte[8];

	static float distance = (float) (Float.parseFloat(Shallwewalk.Ht)*0.37/100);
	static float kcal = distance*(Float.parseFloat(Shallwewalk.Wt))/1000;

	/** Called when the activity is first created. */
	@Override
	/**
	 * ǥ (,Ÿ,) ġ 
	 */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.goal_type);

		load_file();

		RG_goal_group = (RadioGroup)findViewById(R.RadioGroup.Goal_group);
		BT_save = (Button)findViewById(R.Button.goal_save);	
		BT_exit = (Button)findViewById(R.Button.goal_cancel);
		ET_Step = (EditText)findViewById(R.EditText.Step);
		ET_Km = (EditText)findViewById(R.EditText.Km);
		ET_Kcal = (EditText)findViewById(R.EditText.Kcal);

		switch(RG_goal_group.getCheckedRadioButtonId()){
		case R.RadioButton.Step:
			ET_Step.setEnabled(true);
			ET_Kcal.setEnabled(false);
			ET_Km.setEnabled(false);
			ET_Step.setFocusable(true);
			
			break;
		case R.RadioButton.Kcal:
			ET_Step.setEnabled(false);
			ET_Kcal.setEnabled(true);
			ET_Km.setEnabled(false);
			ET_Kcal.setFocusable(true);
			break;
		case R.RadioButton.Km:
			ET_Step.setEnabled(false);
			ET_Kcal.setEnabled(false);
			ET_Km.setEnabled(true);
			ET_Km.setFocusable(true);
			break;
		}
		
		BT_save.setOnClickListener(
				new View.OnClickListener(){   
					public void onClick(View v) {
						if (Save_Goal()){
							save_file();
							Goal_Main.print_goal();
							finish();								
						}
					}
				}
		);

		BT_exit.setOnClickListener(
				new View.OnClickListener(){   
					public void onClick(View v) {
						finish();
					}
				}
		);
		
		RG_goal_group.setOnCheckedChangeListener(
				new RadioGroup.OnCheckedChangeListener(){

					public void onCheckedChanged(RadioGroup group, int checkedId) {
						switch(checkedId){
						case R.RadioButton.Step:
							ET_Step.setEnabled(true);
							ET_Kcal.setEnabled(false);
							ET_Km.setEnabled(false);
							
							break;
						case R.RadioButton.Kcal:
							ET_Step.setEnabled(false);
							ET_Kcal.setEnabled(true);
							ET_Km.setEnabled(false);
							ET_Kcal.setFocusable(true);
							break;
						case R.RadioButton.Km:
							ET_Step.setEnabled(false);
							ET_Kcal.setEnabled(false);
							ET_Km.setEnabled(true);
							ET_Km.setFocusable(true);
							break;
						}
					}
				}
		);
	}
	/**
	 *  ǥ 
	 * @return  true=, false=
	 */
	boolean Save_Goal(){

		boolean flag=true;
		switch(RG_goal_group.getCheckedRadioButtonId()){  //  ư üũ
		case R.RadioButton.Step:		
			if (ET_Step.getText().toString().equals("")){
				Toast.makeText(Goal_Type.this, " Էּ", Toast.LENGTH_LONG).show();
				flag=false;
			}
			else flag = Goal_Step();
			break;
		case R.RadioButton.Km:
			if (ET_Km.getText().toString().equals("")){
				Toast.makeText(Goal_Type.this, " Էּ", Toast.LENGTH_LONG).show();
				flag=false;
			}
			else flag = Goal_Km();
			break;
		case R.RadioButton.Kcal:		
			if (ET_Kcal.getText().toString().equals("")){
				flag=false;
				Toast.makeText(Goal_Type.this, " Էּ", Toast.LENGTH_LONG).show();
			}
			else flag = Goal_Kcal();
			break;
		default:
			flag = false;
		}	
		goal_percent = goal_count * Goal_Alarm.percent / 100; // ǥ % ϱ

		return flag;
	}
	/**
	 * ǥ  
	 * @return  true=, false=
	 */
	boolean Goal_Step(){	//  ǥġ 
		try{
			goal_type = 1;
			goal_count = Integer.parseInt(ET_Step.getText().toString());
			if(goal_count <= 0 ){
				Toast.makeText(this, "ڹ Ȯϼ", Toast.LENGTH_SHORT).show();
				return false;
			}
			return true;
		}catch(Exception e){
			Toast.makeText(this, "ڸ Էϼ", Toast.LENGTH_SHORT).show();
			return false;
		}
	}
	/**
	 * ǥ Ÿ 
	 * @return  true=, false=
	 */
	boolean Goal_Km(){
		try{
			goal_type = 2;
			goal_count = (int) (Integer.parseInt(ET_Km.getText().toString())/ distance )+1;
			if(goal_count <= 0 ){
				Toast.makeText(this, "ڹ Ȯϼ", Toast.LENGTH_SHORT).show();
				return false;
			}
			return true;
		}
		catch(Exception e){
			Toast.makeText(this, "ڸ Էϼ", Toast.LENGTH_SHORT).show();
			return false;
		}
	}
	/**
	 * ǥ  
	 * @return  true=, false=
	 */
	boolean Goal_Kcal(){
		try{
			goal_type = 3;
			goal_count = (int) (Integer.parseInt(ET_Kcal.getText().toString()) / kcal)+1;
			if(goal_count <= 0 ){
				Toast.makeText(this, "ڹ Ȯϼ", Toast.LENGTH_SHORT).show();
				return false;
			}
			return true;
		}
		catch(Exception e){
			Toast.makeText(this, "ڸ Էϼ", Toast.LENGTH_SHORT).show();
			return false;
		}
	}
	/**
	 *   Ͽ ҷ
	 */
	private void load_file(){
		FileInputStream mFileInputStream;
		FileOutputStream mFileOutputStream;

		RG_goal_group = (RadioGroup)findViewById(R.RadioGroup.Goal_group);
		BT_save = (Button)findViewById(R.Button.goal_save);	
		BT_exit = (Button)findViewById(R.Button.goal_cancel);
		ET_Step = (EditText)findViewById(R.EditText.Step);
		ET_Km = (EditText)findViewById(R.EditText.Km);
		ET_Kcal = (EditText)findViewById(R.EditText.Kcal);

		//Ͽ ɼ  б
		try {
			mFileInputStream = openFileInput("save_goal");
			mFileInputStream.read(setting);
		} catch (IOException e){
			for ( int i=0 ; i < 8; i ++) setting[i]=0;
			try {
				mFileOutputStream = openFileOutput("save_goal", MODE_WORLD_WRITEABLE);
				mFileOutputStream.write(setting);
			} catch (IOException e1) {
				Log.d("mylog","can't write");
			}
			Log.d("mylog","can't read");
		}
		int count=0;
		for(int i=0;i<7;i++){
			if(setting[1+i]==0) break;
			count++;
		}
		String goal = new String(setting,1,count);
		if(setting[0]==1){
			RG_goal_group.check(R.RadioButton.Step);
			ET_Step.setText(goal);			
		}			
		if(setting[0]==2){
			RG_goal_group.check(R.RadioButton.Km);
			ET_Km.setText(goal);	
		}
		if(setting[0]==3){
			RG_goal_group.check(R.RadioButton.Kcal);
			ET_Kcal.setText(goal);	
		}		
	}
	/**
	 *   Ͽ 
	 */
	void save_file(){

		int i;
		String goal= null;		
		FileOutputStream mFileOutputStream;

		switch(RG_goal_group.getCheckedRadioButtonId()){ 
		case R.RadioButton.Step:	
			setting[0]=1;
			goal = ET_Step.getText().toString(); 
			break;
		case R.RadioButton.Km:	
			setting[0]=2;
			goal = ET_Km.getText().toString();
			break;
		case R.RadioButton.Kcal:	
			setting[0]=3;
			goal = ET_Kcal.getText().toString();
			break;
		}	
		for (  i =0 ; i < goal.length(); i ++)
			setting[i+1] = goal.getBytes()[i]; 		
		for (i = i+1; i < 8; i ++)	setting[i] = 0; 
		//Ͽ ɼ  
		try {
			mFileOutputStream = openFileOutput("save_goal", MODE_WORLD_WRITEABLE);
			mFileOutputStream.write(setting);
		} catch (IOException e) {
			Log.d("mylog","can't write");
		}
	}
}
