package cnu.app;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class Step_DB_Adapter {
	//////////////////////////////////////////////////////////////////////////////
	//  

	public static final String KEY_STEP_COUNTER ="step_count";	//Ÿ̽  ʵ!
	public static final String KEY_MEMO = "memo";	//Ÿ̽  ʵ!
	public static final String KEY_YEAR = "year"; 	//Ÿ̽  ʵ!
	public static final String KEY_MONTH = "month"; 	//Ÿ̽  ʵ!
	public static final String KEY_DAY = "day"; 	//Ÿ̽  ʵ!
	public static final String KEY_ID = "id"; 	//Ÿ̽  ʵ!
	public static final String KEY_KG = "kg"; 	//Ÿ̽  ʵ!

	private static final String TAG = "Step_DB_Adapter";

	private DatabaseHelper mDbHelper;	//<Ÿ̽ ̳ Ŭ ִ ü> 
	private SQLiteDatabase mDb;			//<Ÿ ̽  > ̴ ü 
	
	//̺  
	private static final String DATABASE_CREATE =
		"create table step_table (id integer primary key autoincrement,"
		+ " year integer not null, month integer not null, day integer not null" +
				",step_count integer not null, memo text, kg float);";

	//Ÿ̽ ̸
	private static final String DATABASE_NAME = "stepdatabases";

	//̺ ̸,
	private static final String DATABASE_TABLE = "step_table";
	private static final int DATABASE_VERSION = 2;

	private final Context mCtx;

	/**
	 * Database  ϰ, Table  Ѵ. 
	 * Database  Ȯ ϰ ʿ ׷̵带 
	 */
	private static class DatabaseHelper extends SQLiteOpenHelper {

		//
		DatabaseHelper(Context context) {
			super(context, DATABASE_NAME, null, DATABASE_VERSION);
		}

		//ͺ̽ ó    ѹ ȴ. 
		public void onCreate(SQLiteDatabase db){
			db.execSQL(DATABASE_CREATE);//츮  ̺   
		} 

		//Ÿ ̽ ׷̵尡 ʿ  
		public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
			Log.w(TAG, "Upgrading database from version " + oldVersion + " to "
					+ newVersion + ", which will destroy all old data");
			onCreate(db);
		}
	}


	/**
	 * Step_DB_Adapter 
	 * @param ctx
	 */
	public Step_DB_Adapter(Context ctx) {
		this.mCtx = ctx;
	}

	/**
	 * Database  Open Ѵ.
	 * @return database ü Return
	 * @throws SQLException 
	 */
	public Step_DB_Adapter open() throws SQLException {
		mDbHelper = new DatabaseHelper(mCtx);	//۸ 
		mDb = mDbHelper.getWritableDatabase(); 	//۷κ  ͼ ̰ ض.
		return this;
	}
	

	/**
	 * Ÿ̽ ݱ.
	 */
	public void close() {
		mDbHelper.close();
	}

	/**
	 *   Ÿ Ѱܹ޾   ִ´.
	 * @param year 	 
	 * @param month  
	 * @param day 	 
	 * @param step_count step 
	 * @param kg	 
	 * @return  ߰ row , ϸ -1
	 */
	public long createStep(int year,int month,int day, int step_count,float kg) {

		//initialValues  ͸ Ƶд.
		ContentValues initialValues = new ContentValues();
		
		initialValues.put(KEY_YEAR, year);
		initialValues.put(KEY_MONTH, month);
		initialValues.put(KEY_DAY, day);
		initialValues.put(KEY_STEP_COUNTER, step_count);
		initialValues.put(KEY_KG, kg);

		return mDb.insert(DATABASE_TABLE, null, initialValues);
	}

	/**
	 * ¥ ġϴ Step  ´.
	 * @param year 	 
	 * @param month	 
	 * @param day	 
	 * @return date   result set Return
	 * @throws SQLException
	 */
	public Cursor fetchStep(int year, int month, int day) throws SQLException {
		Cursor mCursor =
			mDb.query(DATABASE_TABLE, new String[] {KEY_STEP_COUNTER}, 
					"year =" + year +" and month = "+month+" and day = "+day, null,
					null, null, null, null);
		if (mCursor != null) {
			mCursor.moveToFirst();
		}
		return mCursor;
	}
	
	/**
	 * ¥ ġϴ Step  ´.
	 * @param year 	 
	 * @param month	 
	 * @param day	 
	 * @return date   result set Return
	 * @throws SQLException
	 */
	public Cursor fetchDiary(int year, int month, int day) throws SQLException {
		Cursor mCursor =
			mDb.query(DATABASE_TABLE, new String[] {KEY_MEMO,KEY_KG,KEY_STEP_COUNTER}, 
					"year =" + year +" and month = "+month+" and day = "+day, null,
					null, null, null, null);
		if (mCursor != null) {
			mCursor.moveToFirst();
		}
		return mCursor;
	}
	
	/**
	 * Ѵ޺ Ϻ (Step) ´.
	 * @param year	 
	 * @param month  
	 * @return date   result set Return
	 * @throws SQLException
	 */
	public Cursor fetchDayStep(int year, int month) throws SQLException {
		Cursor mCursor =
			mDb.query(true, DATABASE_TABLE, new String[] {KEY_DAY,
					KEY_STEP_COUNTER}, "year =" + year +" and month = "+month, null,
					null, null, "day" , null);
		if (mCursor != null) {
			mCursor.moveToFirst();
		}
		return mCursor;
	}
	
	/**
	 * Ѵ޺ Ϻ () ´.
	 * @param year	 
	 * @param month  
	 * @return date   result set Return
	 * @throws SQLException
	 */
	public Cursor fetchDayKg(int year, int month) throws SQLException {
		Cursor mCursor =
			mDb.query(true, DATABASE_TABLE, new String[] {KEY_DAY,
					KEY_KG}, "year =" + year +" and month = "+month, null,
					null, null, "day" , null);
		if (mCursor != null) {
			mCursor.moveToFirst();
		}
		return mCursor;
	}
	
	/**
	 * ϳ  ޺ (Step) ´.
	 * @param year	 
	 * @return date   result set Return
	 * @throws SQLException
	 */
	public Cursor fetchMonthStep(int year) throws SQLException {
		Cursor mCursor =
			mDb.query(true, DATABASE_TABLE, new String[] {KEY_MONTH,
					"sum(step_count)"}, "year =" + year, null,
					"month", null, "month", null);
		if (mCursor != null) {
			mCursor.moveToFirst();
		}
		return mCursor;
	}
	
	/**
	 * ϳ  ޺ () ´.
	 * @param year
	 * @return date   result set Return
	 * @throws SQLException
	 */
	public Cursor fetchMonthKg(int year) throws SQLException {
		Cursor mCursor =
			mDb.query(true, DATABASE_TABLE, new String[] {KEY_MONTH,
					"avg(kg)"}, "year =" + year, null,
					"month", null, "month", null);
		if (mCursor != null) {
			mCursor.moveToFirst();
		}
		return mCursor;
	}

	/**
	 *  Ʈ()ϴ Լ.
	 * @param year 	 
	 * @param month	 
	 * @param day	 
	 * @return Ʈ ϸ true, ϸ false
	 */
	public boolean updateStep(int year,int month, int day, int step_count) {
		ContentValues args = new ContentValues();

		args.put(KEY_STEP_COUNTER, step_count);

		return mDb.update(DATABASE_TABLE, args, "year =" + year +" and month = "+month+" and day = "+day, null) > 0;
	}
	
	/**
	 * ޸ Ը Ʈ()ϴ Լ.
	 * @param year 	 
	 * @param month	 
	 * @param day	 
	 * @param memo 	޸
	 * @param kg	
	 * @return Ʈ ϸ true, ϸ false
	 */
	public boolean updateDiary(int year,int month, int day, String memo, float kg) {
		ContentValues args = new ContentValues();

		args.put(KEY_MEMO, memo);
		args.put(KEY_KG, kg);

		return mDb.update(DATABASE_TABLE, args, "year =" + year +" and month = "+month+" and day = "+day, null) > 0;
	}
	
	/**
	 * ޸ Ʈ()ϴ Լ.
	 * @param year 	 
	 * @param month	 
	 * @param day	 
	 * @param memo 	޸
	 * @return Ʈ ϸ true, ϸ false
	 */
	public boolean updateDiary(int year,int month, int day, String memo) {
		ContentValues args = new ContentValues();

		args.put(KEY_MEMO, memo);

		return mDb.update(DATABASE_TABLE, args, "year =" + year +" and month = "+month+" and day = "+day, null) > 0;
	}
}
